;; simple functions to get figures drawn

(require "draw-sig.ss")

(unit/sig drawS
  (import plt:userspace^)

  (define (make-error tag)
    (lambda x
      (error "evaluate (start <num> <num>) first")))  

  (define %old-sr (make-error '%oldsr))
  
  (define %old-li (make-error '%old-li))
  
  (define draw-solid-disk (make-error 'draw-solid-disk))

  (define draw-solid-rect (make-error 'draw-solid-rect))
  
  (define draw-solid-line (make-error 'draw-solid-line))

  (define clear-all (make-error 'clear-all))
  
  (define (start WIDTH HEIGHT)
    (open-graphics)
    (set! %old-sr draw-solid-rectangle)
    (set! %old-li draw-line)
    (let ((current-window (open-viewport "Pasteboard" WIDTH HEIGHT)))
      (set! @VP current-window)
      (set! clear-all (clear-viewport current-window))
      (set! draw-solid-line
	(let ((f (draw-line current-window)))
	  (lambda x
	    (apply f x)
	    #t)))
      (set! draw-solid-rect
	(let ([draw-into-my-viewport
		(draw-solid-rectangle current-window)])
	    (lambda x 
	      (apply draw-into-my-viewport x)
	      #t)))
      (set! draw-solid-disk
	(let ([draw-into-my-viewport
		(draw-solid-ellipse current-window)]
	      [tmp-posn (make-posn 0 0)])
	    (lambda (p r . c)
	      (unless (posn? p)
		(error 'draw-solid-disk "position expected as first arg ~s" p))
	      (unless (and (integer? r) (exact? r) (> r 0))
		(error 'draw-solid-disk "positive int as snd arg ~s" r))
	      (let ((x (posn-x p))
		    (y (posn-y p))
		    (d (* r 2))
		    (c (if (null? c) BLACK (car c))))
		(unless (rgb? c)
		  (error 'draw-solid-disk "color as third arg ~s" c))
		(draw-into-my-viewport (make-posn (- x r) (- y r)) d d c)
		#t))))))
  
  (define (stop)
    (set! draw-solid-rect %old-sr)
    (set! draw-solid-line %old-li)
    (close-graphics))
  
  (define @VP #f)

  (define WHITE (make-rgb 1 1 1))
  (define YELLOW (make-rgb 1 1 0))
  (define RED (make-rgb 1.0 0 0))
  (define GREEN (make-rgb 0 1.0 0))
  (define BLUE (make-rgb 0 0 1.0))
  (define BLACK (make-rgb 0 0 0))
  
)
