(define (reveal str knw guess)
  (cond
    ((null? str) null)
    (else (cond
	    ((eq? (first str) guess) 
	     (cons guess      
		   (reveal (rest str) (rest knw) guess)))
	    (else
	     (cons (first knw)
		   (reveal (rest str) (rest knw) guess)))))))

(define (copy str)
  (cond
    ((null? str) null)
    (else (cons '_ (copy (rest str))))))

(define (draw-next-part pieces-left)
  (cond
    ((= pieces-left 1) (draw-left-leg))
    ((= pieces-left 2) (draw-right-leg))
    ((= pieces-left 3) (draw-left-arm))
    ((= pieces-left 4) (draw-right-arm))
    ((= pieces-left 5) (draw-belly))
    ((= pieces-left 6) (draw-head))
    (else (error 'draw-nex-part "impossible"))))

(define (draw-left-leg) (printf "left leg~n"))
(define (draw-right-leg) (printf "right leg.~n"))
(define (draw-left-arm) (printf "left arm~n"))
(define (draw-right-arm) (printf "right arm~n"))
(define (draw-belly) (printf "belly~n"))
(define (draw-head) (printf "head~n"))
(define (draw-noose) (printf "noose~n"))

;; --- our repl ---

(define (hangman-repl str reveal copy draw-next-part)
  (set! pieces-left NUMBER-OF-GUESSES)
  (draw-noose)
  (let repl ((known (copy str)) (guesses null))
    (printf "Take another guess! ")
    (let* ((guess (read))
	   (l (cons guess guesses))
	   (new (reveal str known guess)))
      (cond
	((member guess guesses) (printf "You're losing your memory."))
	((equal? known new) 
	 (draw-next-part pieces-left)
	 (set! pieces-left (- pieces-left 1)))
	(else (printf "Good. Here is what we know: ~a~n" new)))
      (cond
	((= pieces-left 0) (printf "This is the end my friend.~n"))
	((equal? new str) (printf "You won. Good bye."))
	(else (repl new l))))))

(define pieces-left 0)
(define NUMBER-OF-GUESSES 6)
