(unit/sig
  (repl)
  (import (plt : plt:userspace^))

  (define COL# 10)
  
  (define COLORS
    (list 'black 'white 'red 'blue 'green 'gold 'pink 'brown 'purple 'navy))

  (define (repl check-guess)
    ;; --- error checks
    (unless (procedure? check-guess)
      (error 'repl "expects procedure; given ~s" check-guess))
    (unless (and (number? (arity check-guess)) (= (arity check-guess) 4))
      (error 'repl "expects procedure of 4 arguments; given procedure of ~s"
	(arity check-guess)))
    ;; --- check-guess is a procedure of 4 arguments
    (let* ((c1 (list-ref COLORS (random COL#)))
	   (c2 (list-ref COLORS (random COL#)))
	   (ANS-FORM "Not quite, but here is a clue: ~a~n")
	   (err (lambda (repl)
		  (printf "A color is one of:~s~n" COLORS)
		  (printf "You may end the game by typing `quit'.~n")
		  (printf "Try again.")
		  (repl)))
	   (check (lambda (in repl next)
		    (cond
		      ((eq? in 'quit)
		       (printf "The answers were ~s and ~s." c1 c2))
		      ((not (member in COLORS)) (err repl))
		      (else (next in))))))
      (let repl ()
	(display "Your next two guesses please: ") ; (flush-output)
	(check (read) repl
	  (lambda (in1)
	    (check (read) repl
	      (lambda (in2)
		(let ((result (check-guess c1 c2 in1 in2)))
		  (if (eq? result 'PerfectGuess)
		      (printf "Congratulations!")
		      (begin (printf ANS-FORM result) (repl))))))))))))
