;; --------------------------------------------------------------------
(require "draw-lib.ss")

(define-signature rectangleS (show))

(define rectangleU
  (unit/sig
    rectangleS
    (import drawS plt:userspace^)

    ;; show : rectangle -> #t
    (define (show rect)
      (unless (and (list? rect)
		(andmap (lambda (l) (and (list? l) (andmap rgb? l))) rect))
	(error 'show "expected rectangle (list of list of colors); given ~s"
	  rect))

      (let ((x 0) (y 0))
	(for-each (lambda (line)
		    (for-each (lambda (c) 
				(draw-square x y c)
				(set! x (+ x LENGTH-SQUARE)))
			      line)
		    (set! x 0)
		    (set! y (+ y LENGTH-SQUARE)))
		  rect)
	#t))
    
    ;; could be done by students -- after they learn about accumulators
    (define (show2 rect)
      (let OL ((rect rect) (y 0))
	(cond
	  ((null? rect) #t)
	  (else (let IL ((line (first rect)) (x 0))
		  (cond
		    ((null? line) (void))
		    (else (and (draw-square x y (first line))
			       (IL (rest line) (+ x LENGTH-SQUARE))))))
		(OL (rest rect) (+ y LENGTH-SQUARE))))))
    
    ;; draw-square : number number color -> #t
    (define (draw-square y x c)
      (draw-solid-rect (make-posn y x) LENGTH-SQUARE LENGTH-SQUARE c))
    
    (define LENGTH-SQUARE 10)))

(compound-unit/sig (import (PLT : plt:userspace^))
  (link
    [DRAW  : drawS  ((require-unit/sig "draw-lib.ss") PLT)]
    [HANG  : rectangleS (rectangleU DRAW PLT)])
  (export (open DRAW) (open HANG)))

